from pydantic import BaseModel, validator
from datetime import datetime
from typing import Tuple, Optional, List, Dict, Literal, Union

class Variant(BaseModel):
    barcode: Optional[str]
    sku: str
    option_values: List[Dict[str, str]]
    images: Optional[str]
    price: float
    available_qty: Optional[int]

class StandardProduct(BaseModel):
    date: str
    url: str
    source: str
    product_id: Union[str, int]
    existence: bool
    title: str
    title_en: Optional[str]
    description: Optional[str]
    summary: Optional[str]
    sku: str
    upc: Optional[str]
    brand: Optional[str]
    specifications: Optional[List[Dict[str, str]]]
    categories: Optional[str]
    images: str
    videos: Optional[str]
    price: float
    available_qty: Optional[int]
    options: Optional[List[Dict[Literal["name"], str]]]
    variants: Optional[List[Variant]]
    returnable: Optional[bool]
    reviews: Optional[int]
    rating: Optional[float]
    sold_count: Optional[int]
    shipping_fee: float
    shipping_days_min: Optional[int]
    shipping_days_max: Optional[int]
    weight: Optional[float]
    width: Optional[float]
    height: Optional[float]
    length: Optional[float]
    has_only_default_variant: Optional[bool]

